| The Gaudi Framework v30r0 (c919700c)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Attributes | Protected Attributes | List of all members
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ > Class Template Reference

`#include <GaudiAlg/FunctionalDetails.h>`

Inheritance diagram for Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >:
[legend]
Collaboration diagram for Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >:
[legend]

## Public Types
using | KeyValue = std::pair< std::string, std::string >

## Public Member Functions
| DataHandleMixin (const std::string &name, ISvcLocator *pSvcLocator, const std::array< KeyValue, N_in > &inputs, const std::array< KeyValue, N_out > &outputs)
| DataHandleMixin (const std::string &name, ISvcLocator *locator, const KeyValue &input, const KeyValue &output)
| DataHandleMixin (const std::string &name, ISvcLocator *locator, const KeyValue &input, const std::array< KeyValue, N_out > &outputs)
| DataHandleMixin (const std::string &name, ISvcLocator *locator, const std::array< KeyValue, N_in > &inputs, const KeyValue &output)
template<std::size_t N = 0>
const std::string & | inputLocation () const
unsigned int | inputLocationSize () const
template<std::size_t N = 0>
const std::string & | outputLocation () const
unsigned int | outputLocationSize () const

## Static Public Attributes
static constexpr std::size_t | N_in = sizeof...( In )
static constexpr std::size_t | N_out = sizeof...( Out )

## Protected Attributes
std::tuple< details::InputHandle_t< Traits_, In >... > | m_inputs
std::tuple< details::OutputHandle_t< Traits_, Out >... > | m_outputs

## Detailed Description

### template<typename... Out, typename... In, typename Traits_>
class Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >

Definition at line 436 of file FunctionalDetails.h.

## Member Typedef Documentation

template<typename... Out, typename... In, typename Traits_ >

using Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::KeyValue = std::pair<std::string, std::string>

Definition at line 442 of file FunctionalDetails.h.

## Constructor & Destructor Documentation

template<typename... Out, typename... In, typename Traits_ >

Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator,
|  | const std::array< KeyValue, N_in > & | inputs,
|  | const std::array< KeyValue, N_out > & | outputs
| ) |  |
| inline

Definition at line 447 of file FunctionalDetails.h.

449 : BaseClass_t<Traits_>( name, pSvcLocator )
450 , m_inputs( make_tuple_of_handles<decltype( m_inputs )>( this, inputs, Gaudi::DataHandle::Reader ) )
451 , m_outputs( make_tuple_of_handles<decltype( m_outputs )>( this, outputs, Gaudi::DataHandle::Writer ) )
452 {
453 declare_tuple_of_properties( *this, inputs, m_inputs );
454 declare_tuple_of_properties( *this, outputs, m_outputs );
455 // make sure this algorithm is seen as reentrant by Gaudi
456 BaseClass_t<Traits_>::setProperty( "Cardinality", 0 );
457 }
Gaudi::Utils::setProperty
StatusCode setProperty(IProperty *component, const std::string &name, const TYPE &value, const std::string &doc)
simple function to set the property of the given object from the value
Definition: Property.h:1172
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:32
Gaudi::Functional::details::declare_tuple_of_properties
void declare_tuple_of_properties(Algorithm &owner, const KeyValues &inputs, Properties &props)
Definition: FunctionalDetails.h:410
Gaudi::DataHandle::Reader
Definition: DataHandle.h:31
Gaudi::Functional::details::make_tuple_of_handles
Tuple make_tuple_of_handles(IDataHandleHolder *owner, const KeyValues &initvalue, Gaudi::DataHandle::Mode mode)
Definition: FunctionalDetails.h:403
Gaudi::DataHandle::Writer
Definition: DataHandle.h:31
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::m_inputs
std::tuple< details::InputHandle_t< Traits_, In >... > m_inputs
Definition: FunctionalDetails.h:493
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::m_outputs
std::tuple< details::OutputHandle_t< Traits_, Out >... > m_outputs
Definition: FunctionalDetails.h:494
template<typename... Out, typename... In, typename Traits_ >

Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin | ( | const std::string & | name,
|  | ISvcLocator * | locator,
|  | const KeyValue & | input,
|  | const KeyValue & | output
| ) |  |
| inline

Definition at line 461 of file FunctionalDetails.h.

462 : DataHandleMixin( name, locator, std::array<KeyValue, 1>{input}, std::array<KeyValue, 1>{output} )
463 {
464 }
gaudirun.output
output
Definition: gaudirun.py:404
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin
DataHandleMixin(const std::string &name, ISvcLocator *pSvcLocator, const std::array< KeyValue, N_in > &inputs, const std::array< KeyValue, N_out > &outputs)
Definition: FunctionalDetails.h:447
std::array
STL class.
template<typename... Out, typename... In, typename Traits_ >

Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin | ( | const std::string & | name,
|  | ISvcLocator * | locator,
|  | const KeyValue & | input,
|  | const std::array< KeyValue, N_out > & | outputs
| ) |  |
| inline

Definition at line 466 of file FunctionalDetails.h.

468 : DataHandleMixin( name, locator, std::array<KeyValue, 1>{input}, outputs )
469 {
470 }
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin
DataHandleMixin(const std::string &name, ISvcLocator *pSvcLocator, const std::array< KeyValue, N_in > &inputs, const std::array< KeyValue, N_out > &outputs)
Definition: FunctionalDetails.h:447
std::array
STL class.
template<typename... Out, typename... In, typename Traits_ >

Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin | ( | const std::string & | name,
|  | ISvcLocator * | locator,
|  | const std::array< KeyValue, N_in > & | inputs,
|  | const KeyValue & | output
| ) |  |
| inline

Definition at line 472 of file FunctionalDetails.h.

474 : DataHandleMixin( name, locator, inputs, std::array<KeyValue, 1>{output} )
475 {
476 }
gaudirun.output
output
Definition: gaudirun.py:404
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::DataHandleMixin
DataHandleMixin(const std::string &name, ISvcLocator *pSvcLocator, const std::array< KeyValue, N_in > &inputs, const std::array< KeyValue, N_out > &outputs)
Definition: FunctionalDetails.h:447
std::array
STL class.

## Member Function Documentation

template<typename... Out, typename... In, typename Traits_ >
template<std::size_t N = 0>

const std::string& Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::inputLocation | ( |  | ) | const
| inline

Definition at line 479 of file FunctionalDetails.h.

480 {
481 return std::get<N>( m_inputs ).objKey();
482 }
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::m_inputs
std::tuple< details::InputHandle_t< Traits_, In >... > m_inputs
Definition: FunctionalDetails.h:493
template<typename... Out, typename... In, typename Traits_ >

unsigned int Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::inputLocationSize | ( |  | ) | const
| inline

Definition at line 483 of file FunctionalDetails.h.

483 { return std::tuple_size<decltype( m_inputs )>::value; }
template<typename... Out, typename... In, typename Traits_ >
template<std::size_t N = 0>

const std::string& Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::outputLocation | ( |  | ) | const
| inline

Definition at line 486 of file FunctionalDetails.h.

487 {
488 return std::get<N>( m_outputs ).objKey();
489 }
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::m_outputs
std::tuple< details::OutputHandle_t< Traits_, Out >... > m_outputs
Definition: FunctionalDetails.h:494
template<typename... Out, typename... In, typename Traits_ >

unsigned int Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::outputLocationSize | ( |  | ) | const
| inline

Definition at line 490 of file FunctionalDetails.h.

490 { return std::tuple_size<decltype( m_outputs )>::value; }

## Member Data Documentation

template<typename... Out, typename... In, typename Traits_ >

std::tuple<details::InputHandle_t<Traits_, In>...> Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::m_inputs
| protected

Definition at line 493 of file FunctionalDetails.h.

template<typename... Out, typename... In, typename Traits_ >

std::tuple<details::OutputHandle_t<Traits_, Out>...> Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::m_outputs
| protected

Definition at line 494 of file FunctionalDetails.h.

template<typename... Out, typename... In, typename Traits_ >

constexpr std::size_t Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::N_in = sizeof...( In )
| static

Definition at line 443 of file FunctionalDetails.h.

template<typename... Out, typename... In, typename Traits_ >

constexpr std::size_t Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, std::tuple< In... >, Traits_ >::N_out = sizeof...( Out )
| static

Definition at line 444 of file FunctionalDetails.h.

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/FunctionalDetails.h